READ      EQU 3Fh
WRITE     EQU 40h
PRINT     EQU 09h
EXIT      EQU 4Ch
BUFSIZE   EQU 122


; Steko segmentas:
.MODEL small

.STACK 256

; Duomenu segmentas:
.DATA
    skaiciai  DW ?
    skaiciai1  DB '    $'
    nl db 13,10,'$'

    buffer DB BUFSIZE dup (?)

    msg  db'**********************************************',13,10 
    	 db'*** Prasome ivesti eilute (max ilgis 120): ***',13,10,13,10,'$'
    error_msg DB 'cat: fatal error',13,10,'$'
    help db'**********************************************',13,10
    	 db'----------------------------------------------',13,10 
    	 db'**********************************************',13,10
    	 db'1 pratybos, 1 uzduotis:',13,10
    	 db'**********************************************',13,10   	 
    	 db'1. Parasykite programa, kuri leidzia ivesti eilute',13,10
    	 db'zodziu, atskirtu tarpais ir atspausdina siu zodziu ilgius.',13,10 
    	 db'Pvz.: ivedus "asd oprutp paoiujk" turi atspausdinti "3 6 7"',13,10,'$'
    
    
    
    
    
   
.CODE
   Pradzia:
	MOV	ax, @data	;reikalinga kiekvienos programos pradioj
	MOV	ds, ax		;reikalinga kiekvienos programos pradioj

	MOV	bx, 0081h	;programos paleidimo parametrai raomi segmente es pradedant 129 (arba 81h) baitu
   Ieskok:
	MOV	ax, es:[bx]	; ax siraom du baitus,  kuriuos rodo registras bx
	CMP	al, 0Dh		;tikrinam, ar tai ne pabaigos simbolis
	JE	Start		;jei taip, vadinasi neradau "/?"
	CMP	ax, 3F2Fh	;o gal nuskaityta "/?" - 3F = '?'; 2F = '/'
	JE	Yra             ;radau "/?", vadinasi turiu ivesti pagalbos praneim
	INC	bx		;neradau "/?" iuose baituose, paslenku rodykl ir tikrinu toliau esancius parametrus
	JMP	Ieskok		;uciklinu

	;spausdinu pagalba  ekran
   Yra:
	MOV	ah, PRINT		; ah raau dosinio pertraukimo funkcijos numer
	MOV	dx, offset help	; dx raau nuorod  spausdinamo teksto pradi
	INT	21h		;ikvieiu dosin pertraukim - spausdinu praneim

   Start:


    mov ax, stack
    mov ss, ax
    mov ax, @data
    mov ds, ax
    mov es, ax
 

    lea dx, msg
    mov ah, PRINT
    int 21h
    

    lea dx, buffer
    mov ah, READ
    mov bx, 1                       ;Skaitysim is konsoles
    mov cx, BUFSIZE
    int 21h
    jc Error

    xor cx, cx
    xor dx, dx

    mov cx, ax

    xor si, si
    xor di, di
    mov skaiciai, 0

   Ciklas:

    cmp buffer[si], 20h
    je lygu

    inc skaiciai
    inc si

    jmp nelygu

   Lygu:

    cmp skaiciai, 0
    je lygu1

    call Konvertuok

   Lygu1:
    mov skaiciai, 0
    inc si

   Nelygu:

    cmp cx, 0
    je baigt

    loop ciklas
   
   Baigt:

    dec skaiciai
    dec skaiciai

    cmp skaiciai,0
    je lygu2

    call Konvertuok

   Lygu2:

    lea dx, nl
    mov ah, PRINT
    int 21h

   _Exit:
    mov ah, EXIT
    mov al, 0
    int 21h

   Error:

    lea dx, error_msg
    mov ah, PRINT
    int 21h

    jmp _Exit



   Konvertuok PROC

    push dx
    push ax
    push cx
    push bx


    xor dx, dx
    xor ax, ax


    mov ax, skaiciai

    mov bx, 10

    mov cx, 3

   Cikliukas1:
    
    cmp ax,0
    je pabaiga
    
    div bx

    add dx, 30h    
  
    push bx
    mov bx, cx
    mov skaiciai1[bx], dl
    pop bx

    xor dx, dx

    loop cikliukas1
    
   Pabaiga:

    lea dx,skaiciai1
    mov ah,print
    int 21h


    pop bx
    pop cx
    pop ax
    pop dx

    ret
   Konvertuok EndP


endp

end 


